VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDoubleClick"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private currentButton   As MouseType
Private currentTime     As Double
Private currentX        As Long
Private currentY        As Long

Public Function InTime(ByVal lTime As Double) As Boolean
    InTime = ((lTime - currentTime) <= GetDoubleClickTime())
End Function

Public Function InBounds(ByVal x As Long, ByVal y As Long) As Boolean
    Dim wd As Long
    Dim ht As Long
    
    wd = GetSystemMetrics(SM_CXDOUBLECLK) / 2
    ht = GetSystemMetrics(SM_CYDOUBLECLK) / 2
    InBounds = (((x >= (currentX - wd)) And (x < (currentX + wd))) And (((currentY >= (y - ht)) And (currentY <= (y + ht)))))
End Function

Public Function IsDoubleClick(ByVal button As MouseType, ByVal x As Long, ByVal y As Long, ByVal lTime As Double) As Boolean
    Dim isDblClk As Boolean
    
    isDblClk = ((currentButton = button) And (InTime(lTime)) And (InBounds(x, y)))
    ' update history
    currentButton = button
    currentTime = lTime
    currentX = x
    currentY = y
    ' return result
    IsDoubleClick = isDblClk
End Function

Private Sub Class_Initialize()
    currentButton = Others
    currentTime = 0
    currentX = 0
    currentY = 0
End Sub
